/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
/**
 * AUTO GENERATED
 */
/* eslint-disable camelcase */
import { ApiUtils, Network } from '@accelbyte/sdk';
import { UserProfile$ } from './endpoints/UserProfile$';
export function UserProfileApi(sdk, args) {
    const sdkAssembly = sdk.assembly();
    const namespace = args?.namespace ? args?.namespace : sdkAssembly.namespace;
    const cache = args?.cache ? args?.cache : sdkAssembly.cache;
    const requestConfig = ApiUtils.mergedConfigs(sdkAssembly.config, args);
    async function getProfilesPublic(queryParams) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getProfilesPublic(queryParams);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function getUsersMeProfiles() {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getUsersMeProfiles();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function createUserMeProfile(data) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.createUserMeProfile(data);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function updateUserMeProfile(data) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.updateUserMeProfile(data);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function getProfiles_ByUserId(userId) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getProfiles_ByUserId(userId);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function createProfile_ByUserId(userId, data) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.createProfile_ByUserId(userId, data);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function updateProfile_ByUserId(userId, data) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.updateProfile_ByUserId(userId, data);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function getUsersMeProfilesZipCode() {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getUsersMeProfilesZipCode();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function patchUserMeProfileZipCode(data) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.patchUserMeProfileZipCode(data);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function getProfilesPublicByPublicId(queryParams) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getProfilesPublicByPublicId(queryParams);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function getProfilesPublic_ByUserId(userId) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getProfilesPublic_ByUserId(userId);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function patchProfileStatus_ByUserId(userId, data) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.patchProfileStatus_ByUserId(userId, data);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function getProfilesCustomAttributes_ByUserId(userId) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getProfilesCustomAttributes_ByUserId(userId);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function updateProfileCustomAttribute_ByUserId(userId, data) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.updateProfileCustomAttribute_ByUserId(userId, data);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function getUsersMeProfilesPrivateCustomAttributes() {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.getUsersMeProfilesPrivateCustomAttributes();
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    async function updateUserMeProfilePrivateCustomAttribute(data) {
        const $ = new UserProfile$(Network.create(requestConfig), namespace, cache);
        const resp = await $.updateUserMeProfilePrivateCustomAttribute(data);
        if (resp.error)
            throw resp.error;
        return resp.response.data;
    }
    return {
        getProfilesPublic,
        getUsersMeProfiles,
        createUserMeProfile,
        updateUserMeProfile,
        getProfiles_ByUserId,
        createProfile_ByUserId,
        updateProfile_ByUserId,
        getUsersMeProfilesZipCode,
        patchUserMeProfileZipCode,
        getProfilesPublicByPublicId,
        getProfilesPublic_ByUserId,
        patchProfileStatus_ByUserId,
        getProfilesCustomAttributes_ByUserId,
        updateProfileCustomAttribute_ByUserId,
        getUsersMeProfilesPrivateCustomAttributes,
        updateUserMeProfilePrivateCustomAttribute
    };
}
